/* 
   (C) 2004-2007 by Oskar Senft. All rights reserved. 
   
   Published under GPL.
   
   For other licenses, please contact osk@senft-net.com

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.
*/

#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <linux/soundcard.h>


void sigproc(void);

int audioDevice;
int input;

int main() {
    int val;

	/* Install signal handler */

	signal(SIGINT, (void *) sigproc);
	signal(SIGTERM, (void *) sigproc);

	/* /dev/audio stuff */

	if((audioDevice = open("/dev/dsp", O_RDWR)) < 0) {
		printf("Failed to open device /dev/audio.\n");
		return 0;
	}

	val = AFMT_MU_LAW;
	if(ioctl(audioDevice, SNDCTL_DSP_SETFMT, &val) < 0) {
		printf("Can't set format on device /dev/audio.\n");
		close(audioDevice);
		return 0;
	}
	
	val = 8000;
	if(ioctl(audioDevice, SNDCTL_DSP_SPEED, &val) < 0) {
		printf("Can't set samplesize on device /dev/audio.\n");
		close(audioDevice);
		return 0;
	}

	val = 2;
	if(ioctl(audioDevice, SNDCTL_DSP_CHANNELS, &val) < 0) {
		printf("Can't set channels on device /dev/audio.\n");
		close(audioDevice);
		return 0;
	}

	val = 0;
	if(ioctl(audioDevice, SNDCTL_DSP_STEREO, &val) < 0) {
		printf("Can't set stereo on device /dev/audio.\n");
		close(audioDevice);
		return 0;
	}

/* 	val = ; */
/* 	if(ioctl(audioDevice, , &val) < 0) { */
/* 		printf("Can't set  on device /dev/audio.\n"); */
/* 		close(audioDevice); */
/* 		return 0; */
/* 	} */
	
	input = open("/dev/stdin", O_RDONLY);

	while(read(input, &val, 1)) {
	    write(audioDevice, &val, 1);
	}

	close(audioDevice);

	return 0;
}

void sigproc(void)
{
	printf("Caught SIGINT! Exiting.\n");

	close(audioDevice);

	exit(0);
}
